FUNCTION BEAMS_EQUAL, beam1, beam2, help=help

  IF ((KEYWORD_SET(help) NE 0) OR (N_PARAMS() NE 2)) THEN BEGIN
     PRINT, ''
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'BEAMS_EQUAL: function to check whether two beams are equal'
     PSM_INFO_MESSAGE, 'SYNTAX: result = BEAMS_EQUAL(beam1, beam2)'
     PSM_INFO_MESSAGE, "beam1 and beam2 can be FWHMs in arcminutes, or beam structures created by GET_BEAM_STRUCT,"
     PSM_INFO_MESSAGE, "BEAMS_EQUAL will return 1 if the beams are equal, even if they are no described in the same format."
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  IF ISSTRUCT(beam1) THEN b1=beam1 ELSE BEGIN
     IF ISANUMBER(beam1) THEN b1 = GET_BEAM_STRUCT('GAUSSIAN', beamsize=beam1) ELSE MESSAGE, 'Input beam1 format not recognised'
  ENDELSE

  IF ISSTRUCT(beam2) THEN b2=beam2 ELSE BEGIN
     IF ISANUMBER(beam2) THEN b2 = GET_BEAM_STRUCT('GAUSSIAN', beamsize=beam2) ELSE MESSAGE, 'Input beam2 format not recognised'
  ENDELSE

  RETURN, STRUCT_EQUAL(b1, b2)

END 
