PRO GAUSSIAN_NOISE_MAP, nside, sigma, iseed, noise_output, n_obs=n_obs, nobs_ordering=nobs_ordering, noise_ordering=noise_ordering, check=check, double=double

  IF KEYWORD_SET(double) THEN zero=0.d0 ELSE zero=0.0
  IF NOT KEYWORD_SET(noise_ordering) THEN noise_ordering='RING'

  nfields=N_ELEMENTS(sigma)
  npix=12L*nside*nside

  noise=RANDOMN(LONG(iseed),npix,nfields,double=double)
  FOR f=0L,nfields-1 DO noise(*,f)=sigma(f)*TEMPORARY(noise(*,f))
  noise=REORDER(TEMPORARY(noise),in='RING',out=noise_ordering)

  IF KEYWORD_SET(n_obs) THEN BEGIN

     nobstype = SIZE(n_obs, /type)

     ;; If input nobs is in file format
     ;;--------------------------------
     IF nobstype EQ 7 THEN BEGIN
        nobs_npix=GETSIZE_FITS(n_obs,nmaps=nobs_nmaps,nside=nobs_nside,ordering=nobs_ordering)
        READ_TQU, nobs, nobs_data 
        IF KEYWORD_SET(check) THEN BEGIN
           IF MIN(nobs_data) LE 0.d0 THEN BEGIN
              PRINT, "min(nobs) is either zero less than zero in ", n_obs
              STOP
           ENDIF
        ENDIF
     ENDIF

     ;; If input nobs is in array format
     ;;--------------------------------
     IF nobstype LE 5 THEN BEGIN
        nobs_data=n_obs
	IF NOT KEYWORD_SET(nobs_ordering) THEN nobs_ordering='RING'	
        IF KEYWORD_SET(check) THEN BEGIN
           IF MIN(nobs_data) LE 0.d0 THEN BEGIN
              PRINT, "min(nobs) is either zero less than zero in nobs"
              STOP
           ENDIF
        ENDIF
     ENDIF

     nobs_data=REORDER(TEMPORARY(nobs_data),in=nobs_ordering,out=noise_ordering)
     obspix=WHERE(nobs_data GT zero, complement=unobspix)
     IF N_ELEMENTS(obspix) NE npix THEN noise(unobspix,*)=zero
     FOR f=0,nfields-1 DO noise(obspix,f)=TEMPORARY(noise(obspix,f))/SQRT(nobs_data(obspix))
  ENDIF



  noisetype = SIZE(noise_output, /type)
  IF noisetype EQ 7 THEN BEGIN
     IF nfields EQ 1 THEN WRITE_HPXMAP, noise_output, tstokes=noise, ordering=noise_ordering
     IF nfields EQ 3 THEN WRITE_HPXMAP, noise_output, tqustokes=noise, ordering=noise_ordering
  ENDIF

  IF noisetype LE 5 THEN BEGIN
     noise_output=noise
  ENDIF

END

