PRO NOISERMS_TO_NOISEPOWER, sigmanoise, noisepower, npix=npix, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'NOISERMS_TO_NOISEPOWER: procedure to compute the level of the noise power spectrum given its rms per pixel'
     PSM_INFO_MESSAGE, 'SYNTAX: NOISERMS_TO_NOISEPOWER, sigmanoise, noisepower, npix='
     PSM_INFO_MESSAGE, "'sigmanoise' is the input rms healpix map (array), or rms value (number) for white noise"
     PSM_INFO_MESSAGE, "'noisepower' is the output noise power (independent of multipole ell)"
     PSM_INFO_MESSAGE, "If 'sigmanoise' is a scalar, specify the number of pixels in the map with the 'npix' keyword"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF

  IF ISARRAY(sigmanoise) THEN BEGIN
     npix= N_ELEMENTS(sigmanoise)
     noisepower = TOTAL(sigmanoise^2)
     noisepower = 4*!PI*noisepower/npix/npix
  ENDIF ELSE BEGIN
     noisepower = 4*!PI*sigmanoise^2/npix
  ENDELSE

END
