FUNCTION COMPONENT_NEGLIGIBLE, comp, band

  comptype = SIZE(comp,/type)
  IF comptype NE 7 THEN STOP

  isnegligible = 0B

  CASE band.shape OF
     'DIRAC': BEGIN
        numin = band.nu_c
        numax = band.nu_c
     END
     'TOPHAT': BEGIN
        numin = band.nu_min
        numax = band.nu_max
     END
     'TABLE': BEGIN
        numin = MIN(band.nu)
        numax = MAX(band.nu)
     END
     'INSTR': BEGIN
        IF NOT PTR_VALID(band.data) THEN FILL_BAND_DATA, band
        numin = MIN((*band.data).nu)
        numax = MAX((*band.data).nu)
     END
     ELSE: MESSAGE, 'band case not implemented'
  ENDCASE
 
  CASE comp OF
     'dipole': BEGIN
        IF numin GE 1E12 THEN isnegligible=1B
     END
     'cmb': BEGIN
        IF numin GE 1E12 THEN isnegligible=1B
     END
     'synchrotron': BEGIN
        isnegligible=0B
     END
     'freefree': BEGIN
        isnegligible=0B
     END
     'spindust': BEGIN
        IF numin GE 3E11 THEN isnegligible=1B
     END
     'thermaldust': BEGIN
        IF numax LE 1e10 THEN isnegligible=1B
     END
     'co':BEGIN
        nutrans = [1.15271d11, 2.30538d11, 3.45796d11]
        isnegligible=0B
        wh = WHERE((numin LE nutrans) AND (numax GE nutrans), nwh)
        IF nwh EQ 0 THEN isnegligible = 1B
     END
     'thermalsz': BEGIN
        IF numin GE 1E12 THEN isnegligible=1B        
     END
     'kineticsz': BEGIN
        IF numin GE 1E12 THEN isnegligible=1B        
     END
     'firb': BEGIN
        isnegligible=0B
     END
     'radiops': BEGIN
        isnegligible=0B
     END
     'uchii': BEGIN
        isnegligible=0B
     END
     'irps': BEGIN
        isnegligible=0B
     END
     ELSE: isnegligible=0B
  ENDCASE

RETURN, isnegligible

END
