FUNCTION TEST_PSM_DATA, datafile, get=get, private=private, help=help

  IF ((KEYWORD_SET(help) NE 0) OR (N_PARAMS() EQ 0)) THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'TEST_PSM_DATA: function to test whether a PSM data file is available on the local machine'
     PSM_INFO_MESSAGE, 'SYNTAX: result = TEST_PSM_DATA(datafile, get=, private=)'
     PSM_INFO_MESSAGE, 'datafile is the input datafile'
     PSM_INFO_MESSAGE, 'Set /get to get the data file by wget if it is not available.'
     PSM_INFO_MESSAGE, 'Set /private to check also in the private PSM data repository (username and password required).'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

    ok = FILE_TEST(datafile)
    IF KEYWORD_SET(get) NE 0 THEN BEGIN
       COMMON psm, param
       IF DEFINED(param) NE 0 THEN BEGIN
          CASE param.global.getdata OF 
             0: BEGIN
                checkinrep = 0B
             END
             1: BEGIN
                IF NOT ok THEN checkinrep = 1B ELSE checkinrep = 0B
             END
             2: BEGIN
                checkinrep = 1B
             END
          ENDCASE
       ENDIF ELSE BEGIN
          IF NOT ok THEN checkinrep = 1B ELSE checkinrep = 0B
       ENDELSE

       IF checkinrep THEN BEGIN
          IF NOT KEYWORD_SET(private) THEN BEGIN
             GET_PSM_DATA, datafile=datafile, user=user, passwd=passwd
          ENDIF ELSE BEGIN
             GET_PSM_DATA, datafile=datafile, user=user, passwd=passwd
             ok = FILE_TEST(datafile)
             IF NOT ok THEN GET_PSM_DATA, datafile=datafile, /private, user=user, passwd=passwd
          ENDELSE

       ENDIF
       ok = FILE_TEST(datafile)
       IF NOT ok THEN BEGIN
          PSM_INFO_MESSAGE, 'File not retrieved'
       ENDIF
    ENDIF

    RETURN, ok

END
