FUNCTION FITSFILE_PXWIN, fitsfile, exten=exten, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, ''
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'FITSFILE_LMAX: function to get the pixel window function applied in a map or alm fits file'
     PSM_INFO_MESSAGE, 'SYNTAX: result = FITSFILE_PXWIN(fitsfile, exten=)'
     PSM_INFO_MESSAGE, 'By default the extension checked is exten=1'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  IF NOT DEFINED(exten) THEN exten=1
  hd = HEADFITS(fitsfile, exten=exten)
  pxwin = SXPAR(hd, 'PXWIN', count=count)

  IF count EQ 1 THEN RETURN, LONG(pxwin)
  IF PSM_CAREFULNESS() GE 2 THEN MESSAGE, 'Pixel window information unavailable in file '+fitsfile $
  ELSE RETURN, -1

END
