FUNCTION GET_FORMAT, data, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'GET_FORMAT: function to get the format of an input data file'
     PSM_INFO_MESSAGE, 'SYNTAX: result = GET_FORMAT(data)'
     PSM_INFO_MESSAGE, "The ouput is a valid PSM data format, i.e. 'MAP', 'ALM', 'CL', 'CAT'"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF
  
  IF ISFITSFILE(data) THEN BEGIN
     FITS_INFO, data, n_ext=n_ext, /silent
     IF n_ext GE 1 THEN BEGIN
        h = HEADFITS(data,exten=1)
        fmt = SXPAR(h, 'PSM_DTFM', count=count, /silent)
        IF count EQ 1 THEN RETURN, STRTRIM(fmt,2)
     ENDIF ELSE BEGIN
        MESSAGE, "Cannot find format information for file '"+data+"'"
     ENDELSE
  ENDIF ELSE BEGIN
     PSM_DEBUG_MESSAGE, 'Case not implemented', routine='GET_FORMAT'
  ENDELSE

END
