PRO PSM_DEBUG_MESSAGE, info, routine=routine, infolimit=infolimit, stoplimit=stoplimit, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'PSM_DEBUG_MESSAGE: procedure which writes a debug message for PSM developers'
     PSM_INFO_MESSAGE, 'SYNTAX: PSM_DEBUG_MESSAGE, info, routine=, infolimit=, stoplimit='
     PSM_INFO_MESSAGE, 'info is the info to be written'
     PSM_INFO_MESSAGE, 'set routine to the name of the routine in which PSM_DEBUG_MESSAGE is used'
     PSM_INFO_MESSAGE, 'set infolimit to the minimum level of debugging required to give info (default=1)'
     PSM_INFO_MESSAGE, 'set stoplimit to the minimum level of debugging required to stop execution (default=2)'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF

  ON_ERROR, 2

  debug = PSM_DEBUG_VALUE()
  IF NOT DEFINED(infolimit) THEN infolimit=1
  IF NOT DEFINED(stoplimit) THEN stoplimit=2

  IF debug GE infolimit THEN BEGIN
     maxlen = LINE_LENGTH()
     IF DEFINED(routine) THEN PSM_INFO_SUBTITLE, STRUPCASE(routine)+': Developments or debugging needed !'
     nlines = N_ELEMENTS(info)
     DEFSYSV, '!psm_logfile', exists=exists
     FOR i=0, nlines-1 DO BEGIN
        PRINT, '% ----> '+info[i]
        IF exists THEN BEGIN
           GET_LUN, unit
           OPENU, unit, !psm_logfile, /append
           PRINTF, unit, '% ----> '+info[i]
           CLOSE, unit
           FREE_LUN, unit
        ENDIF
     ENDFOR
     PRINT, PSM_STRING_TO_LENGTH('% -',maxlen, character='-')
     IF exists THEN BEGIN
        GET_LUN, unit
        OPENU, unit, !psm_logfile, /append
        PRINTF, unit, PSM_STRING_TO_LENGTH('% -',maxlen, character='-')
        CLOSE, unit
        FREE_LUN, unit
     ENDIF
     IF debug GE stoplimit THEN BEGIN
        MESSAGE, 'Stopping the PSM run', /info
        STOP
     ENDIF
  ENDIF

END
