PRO PREPARE_OUTPUT_DIR, outdir, config_file=config_file

  COMMON psm, param

  outexists = FILE_TEST(outdir,/directory)
  IF NOT outexists THEN BEGIN
     SPAWN, 'mkdir ' + GETPSMDIR('output')
  ENDIF ELSE BEGIN
     IF STRLOWCASE(param.run.clear_all) EQ 'yes' THEN BEGIN
        IF param.tasks.sky_task NE 'new' THEN BEGIN
           PSM_INFO_MESSAGE, 'Cannot set CLEAR_ALL = yes and SKY_TASK = '+param.tasks.sky_task
           PSM_INFO_MESSAGE, 'Fix your parameter file: '+config_file
           PSM_INFO_MESSAGE, 'PSM run aborted !!'
           RETURN
        ENDIF
        IF (PSM_CAREFULNESS() GE 2) THEN BEGIN
           PSM_INFO_MESSAGE, 'Do you really want to erase everything in directory '+GETPSMDIR('output')+' ?'
           PSM_INFO_MESSAGE, 'Execution of the PSM run stopped. Type .c to erase everything and continue'
           STOP
        ENDIF
        FILE_DELETE, GETPSMDIR('ancillary'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('visu'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('info'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('cosmo'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('components'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('observations'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('skyinbands'), /allow_nonexistent, /quiet, /recursive
        FILE_DELETE, GETPSMDIR('private'), /allow_nonexistent, /quiet, /recursive
     ENDIF ELSE BEGIN
        ;; IF PSM_CAREFULNESS() GE 2 THEN BEGIN
        ;;    list = ['dipole','cmb','synchrotron','freefree','spindust','thermaldust','co','sz','ps','firb']
        ;;    eras = BYTARR(N_ELEMENTS(list))
        ;;    FOR i=0, N_ELEMENTS(list)-1 DO ok = EXECUTE("eras[i] = (param.run.clear_"+list[i]+" EQ 'yes')")
        ;;    wh = WHERE(eras EQ 1,nwh)
        ;;    IF nwh NE 0 THEN BEGIN
        ;;       listcomp = ''                 
        ;;       FOR j=0, nwh-1 DO listcomp = listcomp+list[wh[j]]+' '
        ;;       PSM_INFO_MESSAGE, 'Do you REALLY want to erase the following components in directory '+GETPSMDIR('output')+' ?'
        ;;       PSM_INFO_MESSAGE, listcomp
        ;;       PSM_INFO_MESSAGE, 'Execution of the PSM run stopped. Type .c to erase components and continue'
        ;;       STOP
        ;;    ENDIF
        ;; ENDIF
     ENDELSE
  ENDELSE
  ;; directory for some ancillary data
  FILE_MKDIR, GETPSMDIR('ancillary')
  ;; directory for modelled components
  FILE_MKDIR, GETPSMDIR('components')  
  ;; directory for cosmology
  FILE_MKDIR, GETPSMDIR('cosmo')
  ;; directory for plots and figures
  FILE_MKDIR, GETPSMDIR('visu')
  ;; directory for psm run information
  FILE_MKDIR, GETPSMDIR('info')
  ;; directory for file private to the psm
  FILE_MKDIR, GETPSMDIR('private')
  ;; write psm history information
  psm_id = param.run.psm_id
  psm_history_file = GETPSMDIR('info')+'psm_history.sav'
  history_exists = FILE_TEST(psm_history_file)
  IF history_exists THEN BEGIN
     RESTORE, psm_history_file
     psm_history = [psm_history,psm_id]
  ENDIF ELSE BEGIN
     psm_history = [psm_id]
  ENDELSE
  run_number = N_ELEMENTS(psm_history)
  SAVE, psm_history, filename=psm_history_file, verbose=(PSM_VERBOSITY() GE 1)
  SPAWN, 'cp '+config_file+' '+GETPSMDIR('info')+'config-'+NUMBER2STRING(run_number)+'_'+psm_id+'.psm'
  SAVE_PSM_PARAM

END
