PRO READ_PARAM_FILE, psm_file, param_table

  ;;Reads the file discarding empty lines
  ;;and lines which begin with '#'
  line = ""
  table = ['','']
  GET_LUN, unit

  ok = FILE_TEST(psm_file)
  IF ok THEN BEGIN
     file = psm_file
  ENDIF ELSE BEGIN
     IF FILE_BASENAME(psm_file) EQ psm_file THEN BEGIN
        PSM_INFO_MESSAGE, 'Input file not found in working directory.'
        PSM_INFO_MESSAGE, 'Looking for input file in directory PSMROOT/Soft/psm/config/'
        file=FIX_SEPARATOR(!psmroot)+'Soft/psm/config/'+psm_file
        ok = FILE_TEST(file)
        IF ok THEN BEGIN
           PSM_INFO_MESSAGE, 'File found!'
           psm_file = file
        ENDIF
     ENDIF
  ENDELSE

  PSM_INFO_MESSAGE, "Reading PSM configuration parameters"
  PSM_INFO_MESSAGE, "Input file: '"+file+"'"

  OPENR, unit, file
  iline = 0
  WHILE (NOT EOF(unit)) DO BEGIN
    READF, unit, line
    IF FIRSTCHAR(line) NE '@' THEN BEGIN
       iline = iline + 1
       line = STRTRIM(line,2)
       IF STRMID(line, 0, 1) NE '#' AND STRLEN(line) GE 1 THEN BEGIN
          i = STRPOS(line,'=')
          IF i EQ -1 THEN BEGIN
             CLOSE, unit
             message,'Syntax error in parameter file at line ' + STRTRIM(iline,2) + ' : ' + line
          ENDIF
          key=strmid(line, 0, i)
          val=strmid(line, i+1)
          table = [[table],[key,val]]
       ENDIF
    ENDIF ELSE BEGIN
       nchar = STRLEN(line)
       filename = STRMID(line,1,nchar-1)
       filename = STRTRIM(filename,2)
       READ_PARAM_FILE, filename, partable
       IF DEFINED(partable) THEN FOR kkk=0, N_ELEMENTS(partable[0,*])-1 DO table = [[table],[partable[0,kkk],partable[1,kkk]]]
    ENDELSE
  ENDWHILE
  CLOSE, unit
  FREE_LUN, unit
  
  IF N_ELEMENTS(table[0,*]) GT 1 THEN param_table = table[*,1:*]


END
