FUNCTION CMB_BESTFIT_CL, unlensed=unlensed, lmax=lmax, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'CMB_BESTFIT_CL: function which returns the present best fit standard lambda CDM Cl'
     PSM_INFO_MESSAGE, 'SYNTAX: result = CMB_BESTFIT_CL(/unlensed)'
     PSM_INFO_MESSAGE, 'Set /unlensed to get unlensed Cl (lensed is the default)'
     PSM_INFO_MESSAGE, "Set lmax to the maximum value of l requested (dafault: all available l's)"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF

  IF NOT KEYWORD_SET(unlensed) THEN BEGIN
     ;std_lcdm_clfile = GETPSMDIR('psmdata')+'ancillary/models/cmb/standard_lcdm/camb_42481064_lensedcls.dat'
     std_lcdm_clfile = GETPSMDIR('psmdata')+'ancillary/models/cmb/standard_lcdm_cosmo/camb_lensedCls.txt'
  ENDIF ELSE BEGIN
     ;std_lcdm_clfile = GETPSMDIR('psmdata')+'ancillary/models/cmb/standard_lcdm/camb_42481064_scalcls.dat'
     std_lcdm_clfile = GETPSMDIR('psmdata')+'ancillary/models/cmb/standard_lcdm_cosmo/camb_scalCls.txt'
  ENDELSE

  exist_c_ell = FILE_TEST(std_lcdm_clfile)
  IF NOT exist_c_ell THEN GET_PSM_DATA, datafile=std_lcdm_clfile
  exist_c_ell = FILE_TEST(std_lcdm_clfile)
  IF exist_c_ell THEN BEGIN
     IF PSM_VERBOSITY() GE 1 THEN PSM_INFO_SUBTITLE, 'READING INPUT CL FILE'
     READ_CL_ANYFORMAT, std_lcdm_clfile, cl, lmax=lmax, /camb
  ENDIF
  
  cl.c_1_1[0:1] = 0
  cl.c_1_2[0:2] = 0
  cl.c_2_2[0:2] = 0

  RETURN, cl

END
