PRO WRITE_CLASS_PARAM_FILE, file_name, cosmo=cosmo, lmaxs=lmaxs, lmaxt=lmaxt, zpk_array=zpk_array, shells_class=shells_class, $
                            output_dir=output_dir, out_prefix=out_prefix, k_max_hinvMpc=k_max_hinvMpc, format=format, write_background=write_background

  IF DEFINED(out_prefix) EQ 0 THEN out_prefix='run_c_' 
  IF DEFINED(output_dir) EQ 0 THEN output_dir='.'
  IF DEFINED(format) EQ 0 THEN format='class'
  
  ;; IF NOT DEFINED(shells_class) THEN BEGIN
  ;;    window = 'tophat'
  ;;    z = [0,1,2,3,4,5] + 0.5
  ;;    dz = FLTARR(6) + 0.5
  ;;    shells_class = {window:window,z:z,dz:dz}
  ;; ENDIF

  GET_LUN, unit
  openw, unit, file_name 
  
  ;; Cosmological parameters
  ;;-------------------------
  PRINTF, unit, 'h = ' + NUMBER2STRING(cosmo.h)
  PRINTF, unit, 'T_cmb = ' + NUMBER2STRING(cosmo.T_CMB)
  PRINTF, unit, 'Omega_b = ' + NUMBER2STRING(cosmo.OMEGA_B)
  PRINTF, unit, 'N_eff = ' + NUMBER2STRING(cosmo.N_MASSLESS_NU)
  PRINTF, unit, 'Omega_k = ' + NUMBER2STRING(cosmo.OMEGA_K)

  IF cosmo.w_dark_energy EQ -1 THEN BEGIN
     PRINTF, unit, 'Omega_fld = 0'
  ENDIF ELSE BEGIN
     PRINTF, unit, 'Omega_fld = '+strtrim(cosmo.OMEGA_DE,2)
     PRINTF, unit, 'w0_fld = '+NUMBER2STRING(cosmo.w_dark_energy)
     PRINTF, unit, 'wa_fld = 0'
     PRINTF, unit, 'cs2_fld = 1'
  ENDELSE

  PRINTF, unit, 'Omega_cdm = ' + NUMBER2STRING(cosmo.OMEGA_M-cosmo.OMEGA_B)
  PRINTF, unit, 'tau_reio = ' + NUMBER2STRING(cosmo.TAU_REION)
  PRINTF, unit, 'YHe =' + NUMBER2STRING(cosmo.HE_FRACTION)
  PRINTF, unit, 'A_s =' + NUMBER2STRING(cosmo.SCALAR_AMPLITUDE)
  PRINTF, unit, 'k_pivot =' + NUMBER2STRING(cosmo.K_PIVOT)
  PRINTF, unit, 'n_s =' + NUMBER2STRING(cosmo.N_S)
  PRINTF, unit, 'alpha_s = ' + NUMBER2STRING(cosmo.n_s_running)
  PRINTF, unit, 'r = ' + NUMBER2STRING(cosmo.r)
  IF cosmo.r NE 0 THEN PRINTF, unit, 'modes = s,t' ELSE $
     PRINTF, unit, 'modes = s'
  PRINTF, unit, 'n_t = ' + NUMBER2STRING(cosmo.n_t)
  PRINTF, unit, 'alpha_t = 0.'
  PRINTF, unit, 'l_max_scalars = ' + NUMBER2STRING(lmaxs)
  PRINTF, unit, 'l_max_tensors = ' + NUMBER2STRING(lmaxt)

  IF NOT DEFINED(k_max_hinvMpc) THEN BEGIN
     PRINTF, unit,'P_k_max_h/Mpc = 1.'
  ENDIF ELSE BEGIN
     PRINTF, unit,'P_k_max_h/Mpc = ' + NUMBER2STRING(k_max_hinvMpc)
  ENDELSE

  ;; Redshift, width, and window in z of shells of density contrast
  ;;----------------------------------------------------------------


  IF DEFINED(shells_class) THEN BEGIN
     PRINTF, unit,'selection = ' + shells_class.window

     ;; IF NOT DEFINED(zpk_array) THEN zpk_array = shells_class.z

     z_array = shells_class.z
     text='selection_mean = '
     FOR i=0,N_ELEMENTS(z_array)-1 DO BEGIN
        text = text+NUMBER2STRING(z_array[i])
        IF i lt N_ELEMENTS(z_array)-1 THEN text=text+', '
     ENDFOR
     printf, unit, text
     
     text = 'selection_width = '
     z_array = shells_class.dz
     FOR i=0,N_ELEMENTS(z_array)-1 DO BEGIN
        text=text+NUMBER2STRING(z_array[i])
        IF i lt N_ELEMENTS(z_array)-1 THEN text=text+', '
     ENDFOR
     PRINTF, unit, text
  ENDIF

  IF DEFINED(zpk_array) THEN BEGIN
     text = 'z_pk = '
     FOR i=0,N_ELEMENTS(zpk_array)-1 DO BEGIN
        text = text + NUMBER2STRING(zpk_array[i])
        IF i lt N_ELEMENTS(zpk_array)-1 THEN text=text+', '
     ENDFOR
     PRINTF, unit, text
     PRINTF, unit, 'output = tCl,pCl,dCl,lCl,mPk'
  ENDIF ELSE BEGIN
     PRINTF, unit, 'output = tCl,pCl,dCl,lCl'
  ENDELSE

  ;; Output directory and root of file names
  ;;-----------------------------------------
  PRINTF, unit, 'root = '+fix_separator(output_dir)+out_prefix
  PRINTF, unit, 'lensing = yes'

  ;; Default values for other parameters
  ;;-------------------------------------

  ;; PRINTF, unit, 'ncdm_psd_filenames = psd_FD_single.dat'
  ;; PRINTF, unit, 'm_ncdm = 0.04, 0.04, 0.04'
  ;; PRINTF, unit, 'reio_parametrization = reio_camb'
  ;; PRINTF, unit, 'reionization_exponent = 1.5'
  ;; PRINTF, unit, 'reionization_width = 1.5'
  ;; PRINTF, unit, 'helium_fullreio_redshift = 3.5'
  ;; PRINTF, unit, 'helium_fullreio_width = 0.5'
  ;; PRINTF, unit, 'non linear = no'
  ;; PRINTF, unit, 'non linear ic = PT'
  ;; PRINTF, unit, 'ic = ad'
  ;; PRINTF, unit, 'gauge = synchronous'
  ;; PRINTF, unit, 'P_k_ini type = analytic_Pk'
  ;; PRINTF, unit, 'f_bi = 1.'
  ;; PRINTF, unit, 'n_bi = 1.5'
  ;; PRINTF, unit, 'f_cdi=1.'
  ;; PRINTF, unit, 'f_nid=1.'
  ;; PRINTF, unit, 'n_nid=2.'
  ;; PRINTF, unit, 'alpha_nid= 0.01'
  ;; PRINTF, unit, 'c_ad_bi = 0.5'
  ;; PRINTF, unit, 'c_ad_cdi = -1.'
  ;; PRINTF, unit, 'c_bi_nid = 1.'

  PRINTF, unit, 'headers = yes'
  PRINTF, unit, 'format = '+format
  PRINTF, unit, 'bessel file = no'
  
  PRINTF, unit, 'write parameters = yes'  
  PRINTF, unit, 'background_verbose = 1'
  PRINTF, unit, 'thermodynamics_verbose = 1'
  PRINTF, unit, 'perturbations_verbose = 1'
  PRINTF, unit, 'bessels_verbose = 1'
  PRINTF, unit, 'transfer_verbose = 1'
  PRINTF, unit, 'primordial_verbose = 1'
  PRINTF, unit, 'spectra_verbose = 1'
  PRINTF, unit, 'nonlinear_verbose = 1'
  PRINTF, unit, 'lensing_verbose = 1'
  PRINTF, unit, 'output_verbose = 1'
  
  IF KEYWORD_SET(write_background) THEN BEGIN
     PRINTF, unit, 'write background = yes'
  ENDIF ELSE BEGIN
     PRINTF, unit, 'write background = no'
  ENDELSE
  
  CLOSE, unit
  free_lun, unit
  
closing:
END
