PRO ADD_SCALAR_AND_TENSOR, scalarcl, tensorcl, cl

  cl = scalarcl

  cl.C_1_1[cl.L] = cl.C_1_1[cl.L] + tensorcl.C_1_1[cl.L]
  cl.C_2_2[cl.L] = cl.C_2_2[cl.L] + tensorcl.C_2_2[cl.L]
  cl.C_3_3[cl.L] = cl.C_3_3[cl.L] + tensorcl.C_3_3[cl.L]
  cl.C_1_2[cl.L] = cl.C_1_2[cl.L] + tensorcl.C_1_2[cl.L]

END

PRO COSMO_PIPE

  COMMON psm, param
  COMMON sky, model

  cosmodir = GETPSMDIR('cosmo')
  dir_exists = FILE_TEST(cosmodir)
  IF ((dir_exists EQ 0)) THEN FILE_MKDIR, cosmodir

  cmbdir = GETPSMDIR('cmb')

  cambdir = cosmodir+'camb/'
  dir_exists = FILE_TEST(cambdir)
  IF dir_exists eq 0 THEN FILE_MKDIR, cambdir

  classdir = cosmodir+'class/'
  dir_exists = FILE_TEST(classdir)
  IF dir_exists eq 0 THEN FILE_MKDIR, classdir


  ;; Clear the directories if necessary   
  ;;------------------------------------
  docosmo = ((STRLOWCASE(CMB_MODEL()) NE 'no_cmb') OR (STRLOWCASE(SZ_MODEL()) NE 'no_sz') OR (model.global.run_camb EQ 'yes') OR (model.global.run_class EQ 'yes')) AND SKY_TASK() EQ 'new'
  IF docosmo THEN BEGIN
     CLEAR_PSM_DIRECTORY, 'cosmo'
     FILE_MKDIR, GETPSMDIR('cosmo')+'standard'
     FILE_MKDIR, GETPSMDIR('cosmo')+'camb'
     FILE_MKDIR, GETPSMDIR('cosmo')+'class'
  END
  docmb = (STRLOWCASE(CMB_MODEL()) NE 'no_cmb') AND (SKY_TASK() EQ 'new')
  IF docmb THEN BEGIN
     dir_exists = FILE_TEST(cmbdir)
     IF ((dir_exists EQ 0)) THEN FILE_MKDIR, cmbdir
     CLEAR_PSM_DIRECTORY, 'cmb'
  ENDIF
  ;; Filenames to write the theory CMB cl
  ;;--------------------------------------
  cmb_lensedcl_file = cmbdir + 'cmb' + '_lensed_cl.fits' 
  cmb_unlensedcl_file = cmbdir + 'cmb' + '_unlensed_cl.fits' 

  ;; Set sky resolution
  skyres = SKY_RESOLUTION()
  ;; Set sky nside
  skynside = SKY_NSIDE()
  ;; Set sky lmax
  skylmax = SKY_LMAX() 
  ;; Set polar
  IF STRUPCASE(param.global.fields) EQ 'TP' THEN polar = 1 ELSE polar = 0  
  ;; Set sky pixelisation
  skypix = SKY_PIX()

  ;;--------------------------------------------------------------------------------------------------------------------;;
  ;; Get Cl for standard cosmology
  ;;--------------------------------------------------------------------------------------------------------------------;;

  standard_lcdm_dir = GETPSMDIR('psmdata')+'ancillary/models/cmb/standard_lcdm_cosmo/'
  
  filename = 'camb_lensedCls.txt'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','standard_')
  
  filename = 'camb_lensedtotCls.txt'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','standard_')
  
  filename = 'camb_params.ini'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','camb_std_')
  
  filename = 'camb_scalCls.txt'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','standard_')
  
  filename = 'camb_tensCls.txt'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','standard_')
  
  filename = 'camb_totCls.txt'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','standard_')
  
  filename = 'camb.ini'
  file = standard_lcdm_dir + filename
  ok = TEST_PSM_DATA(file, /get)
  IF NOT ok THEN MESSAGE, 'Input standard Lambda CDM model not available'
  FILE_COPY, standard_lcdm_dir+filename, cosmodir+'standard/'+ PSM_STR_REPLACE(filename,'camb_','camb_std_')

  ;; Maximum harmonic modes for power spectra

  lmaxs = skylmax + 300
  lmaxt = skylmax + 100
  lmaxread = skylmax + 300

  ;;--------------------------------------------------------------------------------------------------------------------;;
  ;; Get Cl from CAMB
  ;;--------------------------------------------------------------------------------------------------------------------;;

  IF model.global.run_camb EQ 'yes' THEN BEGIN
     
     ;; We have to change the current working directory to the
     ;; camb directory to run post July 2011 versions of
     ;; camb. This is done below.
     
     ;; Find camb path, and cd to that directory
     cambexecutable = FILE_WHICH(GETENV('PATH'), 'camb')

     necessaryfile = FIX_SEPARATOR(FILE_DIRNAME(cambexecutable))+'HighLExtrapTemplate_lenspotentialCls.dat'

     IF FILE_TEST(necessaryfile) THEN BEGIN
        cambfullpath = FILE_DIRNAME(cambexecutable)
     ENDIF ELSE BEGIN
        cambfileinfo = FILE_INFO(cambexecutable)
        IF cambfileinfo.symlink THEN truecamb = FILE_READLINK(cambexecutable) ELSE truecamb = cambexecutable
        cambfullpath = FILE_DIRNAME(truecamb)
     ENDELSE
     CD, cambfullpath, current=currentdir
     
     ;; Get an absolute filename for the cosmodir directory
     cdir = FIX_SEPARATOR(cosmodir)
     isrelative = 0B

     IF FIRSTCHAR(cosmodir,2) EQ './' THEN BEGIN
        isrelative = 1B
        cdir = FIX_SEPARATOR(currentdir)+STRMID(cosmodir,2,STRLEN(cosmodir)-2) 
     ENDIF 
     IF FIRSTCHAR(cosmodir,3) EQ '../' THEN BEGIN
        isrelative = 1B
        cdir = FIX_SEPARATOR(currentdir)+STRMID(cosmodir,3,STRLEN(cosmodir)-3) 
     ENDIF 
     
     ;; write the CAMB parameter file, run CAMB, store CAMB
     ;; ouputs in cmb directory
     
     redshifts_transfer = [0]
     k_max_hinvMpc = 1.
     
     WRITE_CAMB_PARAM_FILE, model.cosmo, FIX_SEPARATOR(cdir)+'camb/camb.ini', lmaxs=lmaxs, lmaxt=lmaxt, /polar,$
                           /transfer, redshifts_transfer=redshifts_transfer, output_root=FIX_SEPARATOR(cdir)+'camb/camb', k_max_hinvMpc=k_max_hinvMpc
     IF PSM_VERBOSITY() GE 1 THEN PSM_INFO_SUBTITLE, 'RUNNING CAMB'
     
     SPAWN, 'camb ' +FIX_SEPARATOR(cdir)+'camb/camb.ini'
     
     ;; Get back to original working directory
     CD, currentdir              

  ENDIF

  ;;--------------------------------------------------------------------------------------------------------------------;;
  ;; Get Cl from CLASS
  ;;--------------------------------------------------------------------------------------------------------------------;;

  IF model.global.run_class EQ 'yes' THEN BEGIN
     

     window = 'gaussian'

     IF model.firb.model EQ 'castex2012' THEN BEGIN
        ;;z  = [0.2, 0.4, 0.7, 1.0, 1.50, 2.00, 2.50, 3.0, 4.0, 5.0]
        ;;dz = [0.1, 0.1, 0.1, 0.2, 0.25, 0.25, 0.25, 0.3, 0.5, 0.5]/SQRT(2.*ALOG(2))
        
        ; z=[1,2,3]+0.5
        ; dz = FLTARR(N_ELEMENTS(z)) + 0.5/SQRT(2*ALOG(2))

        z  = [0.2, 0.4, 0.7, 1.0, 1.50, 2.00, 2.50, 3.0, 4.0, 5.0]
        dz = [0.1, 0.1, 0.1, 0.2, 0.25, 0.25, 0.25, 0.3, 0.5, 0.5]/SQRT(2.*ALOG(2))

        shells_class = {window:window,z:z,dz:dz,file_cl:''}
     ENDIF

     ;; nbins_pk = 10
     ;; zmax_pk = 5.
     ;; zmin_pk = .01
     ;; arr = (ALOG(zmax_pk)/(nbins_pk-1)) * (FINDGEN(nbins_pk-1)+1)
     zpk_array = [0]
     ;; zpk_array = [0,0.01,0.02,0.05,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8,9,10,15,20,30,40]
     k_max_hinvMpc = 1.

     ;; Run class with class output format
     ;;------------------------------------
     class_param_file = FIX_SEPARATOR(cosmodir)+'class/class.ini'
     WRITE_CLASS_PARAM_FILE, class_param_file, output_dir=FIX_SEPARATOR(cosmodir)+'class/', out_prefix='class_', $
                             cosmo=model.cosmo, lmaxs=lmaxs, lmaxt=lmaxt, format='class', $
                             shells_class=shells_class, zpk_array=zpk_array, k_max_hinvMpc=k_max_hinvMpc, /write_background
     SPAWN, 'class '+class_param_file

     ;; Run class with camb output format
     ;;-----------------------------------
     ;; class_param_file_cambformat = FIX_SEPARATOR(cosmodir)+'class/class_cambformat.ini'
     ;; WRITE_CLASS_PARAM_FILE, class_param_file_cambformat, output_dir=FIX_SEPARATOR(cosmodir)+'class/', out_prefix='camb_', $
     ;;                         cosmo=model.cosmo, lmaxs=skylmax+500, lmaxt=(skylmax>500), format='camb', $
     ;;                         shells_class=shells_class, zpk_array=zpk_array, k_max_hinvMpc=k_max_hinvMpc
     ;; SPAWN, 'class '+class_param_file_cambformat


     IF model.firb.model EQ 'castex2012' THEN BEGIN
        ok = FILE_TEST(GETPSMDIR('cosmo')+'class/class_cls.dat')
        IF ok THEN shells_class.file_cl = GETPSMDIR('cosmo')+'class/class_cls.dat' ELSE shells_class.file_cl = GETPSMDIR('cosmo')+'class/class_cl.dat'
        shellsfile = FIX_SEPARATOR(cosmodir)+'class/shells_class.sav'
        SAVE, filename=shellsfile, shells_class
        shellsfile = FIX_SEPARATOR(cosmodir)+'class/shells_class.txt'
        PRTSTRUCT, shells_class, name='SHELLS', file=shellsfile
        SHELL_DENSITY_CONTRAST, /write
     ENDIF

  ENDIF

  ;;--------------------------------------------------------------------------------------------------------------------;;
  ;; Pick the right Cl for generating the CMB
  ;;--------------------------------------------------------------------------------------------------------------------;;

  IF ((model.cmb.model EQ 'gaussian') OR (model.cmb.model EQ 'nongaussian_fnl')) THEN BEGIN

     scalar_cl_unlensed_standard = cosmodir+'standard/standard_scalCls.txt'
     tensor_cl_unlensed_standard = cosmodir+'standard/standard_tensCls.txt'
     total_cl_lensed_standard = cosmodir+'standard/standard_lensedtotCls.txt'
     scalar_cl_lensed_standard = cosmodir+'standard/standard_lensedCls.txt'
     
     scalar_cl_unlensed_camb = cosmodir+'camb/camb_scalCls.txt'
     tensor_cl_unlensed_camb = cosmodir+'camb/camb_tensCls.txt'
     total_cl_lensed_camb = cosmodir+'camb/camb_lensedtotCls.txt'
     scalar_cl_lensed_camb = cosmodir+'camb/camb_lensedCls.txt'
     
     IF model.cosmo.r EQ 0 THEN scalar_cl_unlensed_class = cosmodir+'class/class_cl.dat' ELSE scalar_cl_unlensed_class = cosmodir+'class/class_cls.dat'
     tensor_cl_unlensed_class = cosmodir+'class/class_clt.dat'
     total_cl_lensed_class = cosmodir+'class/class_cl_lensed.dat'

     CASE model.cmb.cmb_cl_source OF
        ;;-----------------------------------
        'standard-LCDM': BEGIN
           clsource = 'standard'
        END
        ;;-----------------------------------
        'CAMB': BEGIN
           IF model.global.run_camb NE 'yes' THEN MESSAGE, 'Must run CAMB for this case'
           clsource = 'camb'
        END          
        ;;-----------------------------------
        'CLASS': BEGIN
           IF model.global.run_class NE 'yes' THEN MESSAGE, 'Must run CLASS for this case'
           clsource = 'class'
        END          
        ;;-----------------------------------
     ENDCASE

     IF model.global.run_class EQ 'yes' THEN BEGIN
        READ_CLASS_CL, scalar_cl_unlensed_class, clclass_scal_unlensed, format='class', lmin=0, lmax=lmaxread   
        IF model.cosmo.r NE 0 THEN READ_CLASS_CL, tensor_cl_unlensed_class, clclass_tens_unlensed, format='class', lmin=0, lmax=lmaxread
        READ_CLASS_CL, total_cl_lensed_class, clclass_tot_lensed, format='class', lmin=0, lmax=lmaxread
     ENDIF
     IF model.global.run_camb EQ 'yes' THEN BEGIN
        READ_CAMB_CL, scalar_cl_unlensed_camb, clcamb_scal_unlensed, /polar, lmax=lmaxread, cmb_outputscale=1
        IF model.cosmo.r NE 0 THEN READ_CAMB_CL, tensor_cl_unlensed_camb, clcamb_tens_unlensed, /polar, lmax=lmaxread, cmb_outputscale=1
        READ_CAMB_CL, total_cl_lensed_camb, clcamb_tot_lensed, /polar, lmax=lmaxread, cmb_outputscale=1
        ;; READ_CAMB_CL, scalar_cl_lensed_camb, clcamb_scal_lensed, /polar, lmax=lmaxread, cmb_outputscale=1
     ENDIF
     READ_CAMB_CL, scalar_cl_unlensed_standard, clstandard_scal_unlensed, /polar, lmax=lmaxread, cmb_outputscale=7.4311e12
     READ_CAMB_CL, scalar_cl_lensed_standard, clstandard_scal_lensed, /polar, lmax=lmaxread, cmb_outputscale=7.4311e12

     CASE model.cmb.cmb_cl_source OF
        ;;-----------------------------------
        'CLASS': BEGIN
           ;; unlensed cl
           IF model.cosmo.r EQ 0 THEN unlensedcl = clclass_scal_unlensed $  
           ELSE COADD_CL, clclass_scal_unlensed, clclass_tens_unlensed, unlensedcl
           ;; lensed cl
           lensedcl = clclass_tot_lensed
        END
        ;;-----------------------------------
        'CAMB': BEGIN
           ;; unlensed cl
           IF model.cosmo.r EQ 0 THEN unlensedcl = clcamb_scal_unlensed $  
           ELSE COADD_CL, clcamb_scal_unlensed, clcamb_tens_unlensed, unlensedcl
           ;; lensed cl
           IF model.cosmo.r EQ 0 THEN BEGIN
              READ_CAMB_CL, scalar_cl_lensed_camb, lensedcl, /polar, lmax=lmaxread, cmb_outputscale=1
           ENDIF ELSE BEGIN
              lensedcl = clcamb_tot_lensed
           ENDELSE
           ;; ELSE COADD_CL, clcamb_scal_lensed, clcamb_tens_unlensed, lensedcl
        END
        ;;-----------------------------------
        'standard-LCDM': BEGIN
           ;; unlensed cl
           unlensedcl = clstandard_scal_unlensed           
           ;; lensed cl
           lensedcl = clstandard_scal_lensed
        END
     ENDCASE

     ;; Convert units
     ;;---------------
     fields2conv = ['T','E','B']
     units_new = 'uK_CMB'
     FOR i=0, N_ELEMENTS(fields2conv)-1 DO BEGIN & $
        CL_UPDATE_UNITS, unlensedcl, fields2conv[i], units_new & $
        CL_UPDATE_UNITS, lensedcl, fields2conv[i], units_new & $
     ENDFOR

     PSM_ID_KEYGEN, cmb_id
     hbase = PSM_BASE_HDR(datatype='comp',dataform='cl', /setval)
     hcomp = PSM_COMP_HDR(compname='cmb',compid=cmb_id)
     MK_PSMHDR, xhdr, hbase, hcomp 
     WRITE_CL, lensedcl, cmb_lensedcl_file, pxwin=0, beam=0, xhdr=xhdr
     WRITE_CL, unlensedcl, cmb_unlensedcl_file, pxwin=0, beam=0, xhdr=xhdr
     
  ENDIF
  
END
     
