PRO WRITE_DIPOLE_ALM, alm, fitsfile, dipole

  ;; dipole is the dipole component structure (input)

  file_exists = FILE_TEST(fitsfile)
  IF file_exists THEN BEGIN
     IF PSM_CAREFULNESS() GE 2 THEN BEGIN
        PSM_INFO_MESSAGE, 'Dipole alm file already exists: STOPPING THE PSM RUN'
        PSM_INFO_MESSAGE, 'Type .c to delete existing file ('+fitsfile+') and continue'
        STOP
        FILE_DELETE, fitsfile
     ENDIF ELSE BEGIN
        FILE_DELETE, fitsfile
     ENDELSE
  ENDIF        
  IF PSM_VERBOSITY() GE 1 THEN PSM_INFO_SUBTITLE, 'WRITING THE DIPOLE ALM'
  DIPOLE_ALM_HEADER, hdr, id=dipole.id
  PSM_ID_KEYGEN, dipolealmkey
  UPDATEHDRPAR, hdr, 'PSM_DTID', dipolealmkey
  UPDATEHDRPAR, hdr, 'ALM_FLD', 'T       '
  skypix = SKY_PIX()

  WRITE_ALM, alm, fitsfile, coordsys=skypix.coordsys

  h = HEADFITS(fitsfile, exten=1)
  extname = SXPAR(h,'EXTNAME',count=count)
  ;; Add units
  SXADDPAR, h, 'TUNIT1', 'unitless', after='TFORM1'
  SXADDPAR, h, 'TUNIT2', dipole.e1.ampl.unit, after='TFORM2'
  SXADDPAR, h, 'TUNIT3', dipole.e1.ampl.unit, after='TFORM3'

  ;; Add PSM HEADER
  nel = N_ELEMENTS(h)
  h = [h[0:nel-2],hdr,h[nel-1]]
  MODFITS, fitsfile, 0, h, exten_no=1

END
