FUNCTION PROTO_SPH_BIAS, z, bias_model=bias_model

IF NOT DEFINED(bias_model) THEN bias_model='dezotti'


CASE bias_model OF
   'dezotti': BEGIN
      filename=GETPSMDIR('psmdata')+'ancillary/models/firb/GC-2012/'+'b_z_proto-spheroids.dat'
      ok = TEST_PSM_DATA(filename, /get)
      IF NOT ok THEN MESSAGE, 'File not available: '+filename
      
      a=read_ascii(filename)
      
      z_dat=(a.field1)[0,*]
      bias_dat=(a.field1)[1,*]
      bias=interpol(bias_dat, z_dat, z)
   END
   'xia_planck': BEGIN
      filename=GETPSMDIR('psmdata')+'ancillary/models/firb/GC-2012/July2012/mcmc_results/'+'planck.bias.PS.dat'
      ok = TEST_PSM_DATA(filename, /get)
      IF NOT ok THEN MESSAGE, 'File not available: '+filename
      
      a=read_ascii(filename)
      
      z_dat=reform((a.field1)[0,*])
      bias_dat=reform((a.field1)[1,*])
      bias=interpol(bias_dat, z_dat, z)
   END
   'xia_hermes': BEGIN
      filename=GETPSMDIR('psmdata')+'ancillary/models/firb/GC-2012/July2012/mcmc_results/'+'hermes.bias.PS.dat'
      ok = TEST_PSM_DATA(filename, /get)
      IF NOT ok THEN MESSAGE, 'File not available: '+filename
      
      a=read_ascii(filename)
      
      z_dat=reform((a.field1)[0,*])
      bias_dat=reform((a.field1)[1,*])
      bias=interpol(bias_dat, z_dat, z)


;;;;;;;warning!!!!!


 b=3.2
 a=0.1  
  
      bias=a*z^2+b

   END
   'test_bias': BEGIN

 b=3.
 a=0.1  
  
      bias=a*z^2+b
IF 0 THEN BEGIN
      filename=GETPSMDIR('psmdata')+'ancillary/models/firb/GC-2012/July2012/mcmc_results/'+'hermes.bias.PS.dat'
      ok = TEST_PSM_DATA(filename, /get)
      IF NOT ok THEN MESSAGE, 'File not available: '+filename
      
      a=read_ascii(filename)
      
      z_dat=reform((a.field1)[0,*])
      bias_dat=reform((a.field1)[1,*])
      bias=interpol(bias_dat, z_dat, z)*1./(-0.01+exp(z/35))
   ENDIF

;bias=2.5+z*0

   END
ENDCASE

RETURN, bias

END





