; -----------------------------------------------------------------------------
;
; Copyright (C) 2010
;   Jacques Delabrouille
;   Guillaume Castex
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
;-
PRO REMOVE_SRC_CAT, sources, cat, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'REMOVE_SRC_CAT: procedure to remove a point source from a  catalog'
     PSM_INFO_MESSAGE, 'SYNTAX: REMOVE_SRC_CAT, sources, cat'
     PSM_INFO_MESSAGE, "sources is an array of index to remove from the catalogue"
     PSM_INFO_MESSAGE, "cat is a pointer to the catalogue"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF
  
  fields = RECURSIVE_TAG_NAMES(*cat)
  nfields = N_ELEMENTS(fields)


  sources = sources[UNIQ(sources,SORT(sources))]

  nremove = N_ELEMENTS(sources)
  nsources_defined = WHERE(fields eq 'NSOURCES', nnwh)
  if nnwh eq 0 then begin
     print, 'NSOURCES does not exists in catalogue, check this'
     STOP 
  endif

  
  nsrc = (*cat).nsources
  indix = LINDGEN(nsrc)
  indix[sources] = -1
  ind_p = WHERE(indix GE 0)
  indix = indix[ind_p]

  (*cat).nsources=nsrc-nremove

  FOR i=0,nfields-1 DO BEGIN
     ok = EXECUTE('s = size((*cat).'+fields[i]+',/TYPE)')
     if s eq 10 then BEGIN

        ok = EXECUTE('s = size(*(*cat).'+fields[i]+',/DIMENSIONS)') 
        ;s=s[0:n_elements(s)-2]
        to_edit = WHERE(s EQ nsrc)
        IF to_edit NE -1 then BEGIN
          if n_elements(s) gt 1 then BEGIN
             MESSAGE, 'Case not implemented'
             STOP
          endif

          ok = EXECUTE('*(*cat).'+fields[i]+'=(*(*cat).'+fields[i]+')[indix]') 
        endif
     endif else begin
        ok = EXECUTE('s = size((*cat).'+fields[i]+',/DIMENSIONS)')
        to_edit = where(s eq nsrc)
        if to_edit ne -1 then BEGIN
           print, 'edit this if needed'
         
        endif
     endelse
  ENDFOR

END


  
  

