PRO COMPARE_PSM_TO_WMAP

  ;; psm_main, 'config-WMAP-prediction.psm', /debug
  
  band = ['K','Ka','Q','V','W']
  maxmap = [5.,5.,5.,.5,.5]
  minmap = [-.5,-.5,-.5,-.5,-.5]
  maxdif = [.5,.5,.5,.5,.5]
  hist = [1,1,1,0,0]
  
  FILE_MKDIR, 'PSM_OUTPUT_WMAP/figures/comparison/'
  
  FOR i=0, 4 DO BEGIN
     wmapfile = GETPSMDIR('psmdata')+'ancillary/observations/WMAP/wmap_band_iqumap_r9_sevenyear_v4/wmap_band_iqumap_r9_7yr_'+band[i]+'_v4.fits'
     READ_FITS_MAP, wmapfile, map & map=map[*,0] & map=REORDER(map,/n2r)
     beam = GET_BEAM_STRUCT('INSTR',instr='WMAP',version='7yr',channel=band[i])
     bl = PSM_GET_BL(beam) & lmax = MAX(WHERE(bl NE 0))
     CHANGE_MAP_RESOLUTION, map, map1deg, beam_in=beam, beam_out=60, /iter, lmax=lmax, /overwrite
     psmfile = 'PSM_OUTPUT_WMAP/observations/WMAP/'+band[i]+'/group1_map_'+band[i]+'.fits'
     READ_FITS_MAP, psmfile, m
     wdel
     MOLLVIEW, m, max=maxmap[i], min=minmap[i], title='PSM, 1 deg resolution, band '+band[i], hist_equal=hist[i], units='mK_CMB', ps='PSM_OUTPUT_WMAP/figures/comparison/psm_'+band[i]+'.ps'
     MOLLVIEW, map1deg, max=maxmap[i], min=minmap[i], title='WMAP, 1 deg resolution, band '+band[i], hist_equal=hist[i], units='mK_CMB', ps='PSM_OUTPUT_WMAP/figures/comparison/wmap_'+band[i]+'.ps'
     MOLLVIEW, ABS(m-map1deg), max=maxdif[i], min=0, title='ABS(PSM-WMAP), 1 deg resolution, band '+band[i], units='mK_CMB', ps='PSM_OUTPUT_WMAP/figures/comparison/absdiff_'+band[i]+'.ps'
     MOLLVIEW, m-map1deg, max=maxdif[i], min=-maxdif[i], title='PSM-WMAP, 1 deg resolution, band '+band[i], units='mK_CMB', ps='PSM_OUTPUT_WMAP/figures/comparison/diff_'+band[i]+'.ps'
     MOLLVIEW, m, max=maxmap[i], min=minmap[i], title='PSM, 1 deg resolution, band '+band[i], hist_equal=hist[i], units='mK_CMB', png='PSM_OUTPUT_WMAP/figures/comparison/psm_'+band[i]+'.png', charsize=2, charthick=2
     MOLLVIEW, map1deg, max=maxmap[i], min=minmap[i], title='WMAP, 1 deg resolution, band '+band[i], hist_equal=hist[i], units='mK_CMB', png='PSM_OUTPUT_WMAP/figures/comparison/wmap_'+band[i]+'.png', charsize=2, charthick=2
     MOLLVIEW, ABS(m-map1deg), max=maxdif[i], min=0, title='ABS(PSM-WMAP), 1 deg resolution, band '+band[i], units='mK_CMB', png='PSM_OUTPUT_WMAP/figures/comparison/absdiff_'+band[i]+'.png', charsize=2, charthick=2
     MOLLVIEW, m-map1deg, max=maxdif[i], min=-maxdif[i], title='PSM-WMAP, 1 deg resolution, band '+band[i], units='mK_CMB', png='PSM_OUTPUT_WMAP/figures/comparison/diff_'+band[i]+'.png', charsize=2, charthick=2
  ENDFOR
  
END
