PRO RUN_GAL_CASE, resol, output_directory, fields, polar_model, sync_emlaw, sync_index, ffmap, simutype

  PSM_INFO_MESSAGE, 'FIELDS = ' + fields
  PSM_INFO_MESSAGE, 'GAL_MODEL = ' + simutype
  PSM_INFO_MESSAGE, 'GAL_POLAR_MODEL = ' + polar_model
  PSM_INFO_MESSAGE, 'SYNCHROTRON_EMISSION_LAW = ' + sync_emlaw
  PSM_INFO_MESSAGE, 'SYNCHROTRON_INDEX_MODEL = ' + sync_index
  PSM_INFO_MESSAGE, 'FREEFREE_TEMPLATE = ' + ffmap

  GET_LUN, unit
  paramfile = PSM_TMPFILENAME(extension='.psm')
  OPENW, unit, paramfile
  PRINTF, unit, 'OUTPUT_DIRECTORY = ' + output_directory
  PRINTF, unit, 'FIELDS = ' + fields
  PRINTF, unit, 'CLEAR_ALL = yes'
  PRINTF, unit, 'VISU = 2'
  PRINTF, unit, 'OUTPUT_VISU = ps'
  PRINTF, unit, 'SKY_RESOLUTION = ' + NUMBER2STRING(resol)
  PRINTF, unit, 'SKY_LMAX = ' + NUMBER2STRING(RESOL2LMAX(resol))
  PRINTF, unit, 'SKY_PIXELISATION = HEALPIX'
  PRINTF, unit, 'HEALPIX_NSIDE = ' + NUMBER2STRING(RESOL2NSIDE(resol))

  PRINTF, unit, 'FIELDS = ' + fields
  PRINTF, unit, 'GAL_MODEL = ' + simutype
  PRINTF, unit, 'GAL_POLAR_MODEL = ' + polar_model
  PRINTF, unit, 'SYNCHROTRON_EMISSION_LAW = ' + sync_emlaw
  PRINTF, unit, 'SYNCHROTRON_INDEX_MODEL = ' + sync_index
  PRINTF, unit, 'FREEFREE_TEMPLATE = ' + ffmap
  PRINTF, unit, 'I100 = FFP6-JD'

  PRINTF, unit, 'OBS_TASK = new'
  PRINTF, unit, 'WHAT_OBS = bandinteg'
  PRINTF, unit, 'INSTRUMENT = PSM_IDEAL'
  PRINTF, unit, 'OBS_FREQUENCIES =  150'
  PRINTF, unit, 'OBS_STOKES = ' + fields

  CLOSE, unit
  FREE_LUN, unit
  PSM_MAIN, paramfile, /debug, verbosity=0

END

PRO TEST_GALAXY, resol=resol, nsample=nsample, exhaustive=exhaustive, pickruncase=pickruncase

  IF NOT KEYWORD_SET(resol) THEN resol=120         ; 120 arcminutes
  output_directory = GETPSMDIR('psmroot') + 'Test/PSM_OUTPUT_galaxy_'
  
  listparam = ['FIELDS', 'POLAR_MODEL', 'SYNC_EMLAW', 'SYNC_IND', 'FFMAP', 'SIMUTYPE']

  fields_list = ['T','TP']
  polar_model_list = ['mamd2008','fauvet2011']
  sync_emlaw_list = ['powerlaw','curvpowerlaw']
  sync_index_list = ['giardino2002', 'mamd2008', 'uniform']
  ffmap_list = ['dickinson_h_alpha', 'wmap_mem', 'mamd2008']
  simutype_list = ['prediction', 'simulation']

  runcase=1L

  ncases = LONG(N_ELEMENTS(fields_list)) * LONG(N_ELEMENTS(polar_model_list)) * LONG(N_ELEMENTS(sync_emlaw_list)) * LONG(N_ELEMENTS(sync_index_list)) * $
           LONG(N_ELEMENTS(ffmap_list)) * LONG(N_ELEMENTS(simutype_list))

  IF ((KEYWORD_SET(exhaustive)) OR (KEYWORD_SET(pickruncase))) THEN BEGIN

     FOR f=0,1 DO FOR pm=0,1 DO FOR se=0,1 DO FOR si=0,2 DO FOR ff=0,2 DO FOR st=0,1 DO BEGIN
        
        IF KEYWORD_SET(pickruncase) NE 0 THEN BEGIN
           IF runcase NE pickruncase THEN GOTO, nextcase
        ENDIF

        fields = fields_list[f]
        polar_model = polar_model_list[pm]
        sync_emlaw = sync_emlaw_list[se]
        sync_index = sync_index_list[si]
        ffmap = ffmap_list[ff]
        simutype = simutype_list[st]

        PSM_INFO_TITLE, 'RUN CASE '+NUMBER2STRING(runcase)+': '
        
        output_directory_n = output_directory + NUMBER2STRING(runcase)
        
        RUN_GAL_CASE, resol, output_directory_n, fields, polar_model, sync_emlaw, sync_index, ffmap, simutype

        nextcase:
        runcase = runcase + 1L
     ENDFOR

  ENDIF ELSE BEGIN

     IF NOT KEYWORD_SET(nsample) THEN nsample=1
     draw = RANDOMU(noseed,nsample)
     cases = LONG(ncases*draw)

     FOR i=0L, nsample-1 DO BEGIN
        TEST_GALAXY, resol=resol, pickruncase = cases[i]
     ENDFOR

  ENDELSE

END
