; -----------------------------------------------------------------------------
;
; Copyright (C) 2009
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	EMLAW_SETVALUE
;
; PURPOSE:
;	...
;
;-
PRO EMLAW_SETVALUE, paramstruct, param, value=value, form=form, unit=unit, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'EMLAW_SETVALUE: procedure to set the value of a parameter in an emission law parameter structure'
     PSM_INFO_MESSAGE, 'SYNTAX: EMLAW_SETVALUE, paramstruct, param, value=, form=, unit='
     PSM_INFO_MESSAGE, "param is the name of a parameter to the emission law in the structure"
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN
  ENDIF


  IF DEFINED(value) THEN BEGIN
     ;; Is the value passed by pointer ?
     IF ISPOINTER(value) THEN BEGIN
        ok = EXECUTE('paramstruct. '+ param + '.value = value')
     ENDIF ELSE BEGIN
        ok = EXECUTE('*paramstruct. '+ param + '.value = value')
     ENDELSE
  ENDIF
  
  PSM_DEBUG_MESSAGE, 'Implement form of parameter value', routine='EMLAW_SETVALUE'

  IF DEFINED(form) THEN BEGIN
     ;; Check that the form is compatible with the value
     
  ENDIF ELSE BEGIN
     ;; Guess the form from the type of the value pointed at

  ENDELSE

  ;; Assign the form
  IF DEFINED(form) THEN ok = EXECUTE('paramstruct. '+ param + '.form = form')
     
  ;; Assign the unit
  IF DEFINED(unit) THEN ok = EXECUTE('paramstruct. '+ param + '.unit = unit')

     
     
END
  
