; -----------------------------------------------------------------------------
;
; Copyright (C) 2011, 2012
;   Jacques Delabrouille
;   Samuel Leach
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	ISANUMBER
;
; PURPOSE:
;	...
;
;-
FUNCTION ISANUMBER, data, help=help

  IF (KEYWORD_SET(help) NE 0) OR (N_PARAMS() NE 1) THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'ISANUMBER: function which returns 1 if data is a number, or an array of numbers, and 0 otherwise'
     PSM_INFO_MESSAGE, 'SYNTAX: result = ISANUMBER(data)'
     RETURN, 0
  ENDIF

  s = SIZE(data,/type)
  isnum=[1,2,3,4,5,12,13,14,15]
  wh = WHERE(isnum EQ s, nwh)
  IF nwh EQ 1 THEN RETURN, 1B ELSE RETURN, 0B
END
