FUNCTION HPX_PIX_SIGMA, map_in, m, maxremote=maxremote, minremote=minremote, ordering=ordering

  ;; Default values for keywords
  ;;-----------------------------
  IF NOT KEYWORD_SET(minremote) THEN minremote=0
  IF NOT KEYWORD_SET(maxremote) THEN maxremote=minremote>1
  IF NOT KEYWORD_SET(ordering) THEN ordering='RING'

  ;; Create kernel for convolution
  ;;-------------------------------
  kernelpix = FLTARR(maxremote+1)
  kernelpix[minremote:maxremote] = 1
  weights = REPLICATE(0,maxremote+1) & FOR r=1L,maxremote DO weights[r] = (8.*r)>1
  kernelpix = kernelpix/TOTAL(weights)

  ;; Create output array
  ;;---------------------
  map_out = map_in
  nside = GET_NSIDE(map_in)

  ;; Compute mean
  ;;--------------
  IF NOT KEYWORD_SET(silent) THEN PRINT, 'Computing local average value'
  HPX_PIX_CONVOL, map_in, m, kernelpix=kernelpix, ordering=ordering, silent=silent

  ;; Variance
  ;;----------
  HPX_PIX_CONVOL, (map_in-m)^2, map_out, kernelpix=kernelpix, ordering=ordering, silent=silent

  RETURN, SQRT(map_out)

END
