; -----------------------------------------------------------------------------
;
; Copyright (C) 2009, 2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	COSECANT_MASK
;
; PURPOSE:
;	...
;
;-
FUNCTION COSECANT_MASK, nside=nside, ordering=ordering

npix = LONG(nside)^2*12L

IF NOT KEYWORD_SET(ordering) THEN ordering='RING'

CASE STRUPCASE(ordering) OF
   'RING': BEGIN
      PIX2ANG_RING, nside, LINDGEN(npix), mask
      mask = ABS(COS(TEMPORARY(mask)))
   END
   'NEST': BEGIN
      PIX2ANG_NEST, nside, LINDGEN(npix), mask
      mask = ABS(COS(TEMPORARY(mask)))
   END
ENDCASE

RETURN, mask

END
