;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; --- Given by Andrea Lapi at Apr 18, 2012 --- ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; --- Given matrix: M[m, n] & X[m] & Y[n] ---  ;
;; ---            X 0, 1, ..., m                ;
;; ---          Y  [            ]               ;
;; ---          0  [            ]               ;
;; ---          1  [            ]               ;
;; ---         ... [            ]               ;
;; ---          n  [            ]               ;
;; --- Usage: biliin, X, Y, M, X0, Y0, M0   --- ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro biliin, x1a, x2a, ya, x1, x2, y

;   By Gian Luigi - translated and adapted on 3-10-02 form f90 Version 16-12-97
;   dati gli arrays X1A(M) e X1A(N) delle variabili indipendenti,
;   e l'array YA(M,N) della funzione, ritorna Y, ovvero un array di
;   valori interpolati nei punti specificati dai due arrays x1 ed x2

	m=n_elements(x1a) & my=n_elements(ya[*,0])
	n=n_elements(x2a) & ny=n_elements(ya[0,*])

	if m ne my or n ne ny then stop, 'FATAL ERROR: Arrays dimensions mismatch'

;   localizziamo X1 e X2 nei rispettivi arrays
	i=value_locate(x1a,x1)
	j=value_locate(x2a,x2)

	index=where(i eq m-1, count)
	if count ne 0 then  i[where(i eq m-1)]=i[where(i eq m-1)]-1
	index=where(i eq -1, count)
	if count ne 0 then i[where(i eq -1)]=i[where(i eq -1)]+1
	index=where(j eq n-1, count)
	if count ne 0 then  j[where(j eq n-1)]=j[where(j eq n-1)]-1
	index=where(j eq -1, count)
	if count ne 0 then j[where(j eq -1)]=j[where(j eq -1)]+1

; finally interpolate (num. rec. pag. 96)

	ti=(x1-x1a[i])/(x1a[i+1]-x1a[i])
	u=(x2-x2a[j])/(x2a[j+1]-x2a[j])
	c1=(1-ti)#(1-u) & c2=ti#(1-u) & c3=ti#u & c4=(1-ti)#u
	;y=fltarr(n_elements(x1),n_elements(x2))
	y=dblarr(n_elements(x1),n_elements(x2))

; I can't find a way to avoid one of the two cycle do
	for it=0,n_elements(x1)-1 do begin
		y[it,*]=c1[it,*]*ya[i[it],j]+c2[it,*]*ya[i[it]+1,j]+ $
			c3[it,*]*ya[i[it]+1,j+1]+c4[it,*]*ya[i[it],j+1]
	end

END; pro biliin