; -----------------------------------------------------------------------------
;
; Copyright (C) 2010,2012
;   Jacques Delabrouille
;
; This file is part of the Planck Sky Model (PSM).
;
; The Planck Sky Model is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; The Planck Sky Model is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with the Planck Sky Model.  If not, see <http://www.gnu.org/licenses/>.
;
; For more information about the PSM see:
; http://www.apc.univ-paris7.fr/~delabrou/PSM/psm.html
; or contact Jacques Delabrouille (delabrouille@apc.univ-paris7.fr)
;
; -----------------------------------------------------------------------------
;+
; NAME:
;	ALPHABET
;
; PURPOSE:
;	Function which returns a 26-element string array containing
;	all letters of the alphabet, in alphabetical order.
;
; CATEGORY:
;	String handling
;
; CALLING SEQUENCE:
;	Result = ALPHABET()
;
; INPUTS:
;	None
;
; KEYWORD PARAMETERS:
;	None
;
; OUTPUTS:
;	Result is a 26-element string array (the alphabet).
;
; RESTRICTIONS:
;	Report any bugs to Jacques Delabrouille
;	delabrouille@apc.univ-paris7.fr
;
; MODIFICATION HISTORY:
; 	01/10/2010:	Jacques Delabrouille, First version.
; 	20/09/2012:	JD, doc header.
;-
FUNCTION ALPHABET, help=help

  IF KEYWORD_SET(help) NE 0 THEN BEGIN
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     PRINT, 'ALPHABET: function which returns a 26-element string array containing all letters of the alphabet'
     PSM_INFO_MESSAGE, 'SYNTAX: result = ALPHABET()'
     PRINT, PSM_STRING_TO_LENGTH('-',LINE_LENGTH(),character='-')
     RETURN, 0
  ENDIF


RETURN, ['A','B','C','D','E','F','G','H','I','J','K','L','M',$
         'N','O','P','Q','R','S','T','U','V','W','X','Y','Z']

END
